#include "Elements.h"

#include <RobotAPI/libraries/ArmarXObjects/ObjectID.h>
#include <RobotAPI/libraries/ArmarXObjects/ObjectInfo.h>
#include <RobotAPI/libraries/ArmarXObjects/ObjectFinder.h>


namespace armarx::viz
{

    const std::string Object::DefaultObjectsPackage = armarx::ObjectFinder::DefaultObjectsPackageName;
    const std::string Object::DefaultRelativeObjectsDirectory = armarx::ObjectFinder::DefaultObjectsDirectory;

    Object& Object::fileByObjectFinder(const std::string& objectID, const std::string& objectsPackage,
                                       const std::string& relativeObjectsDirectory)
    {
        return this->fileByObjectFinder(armarx::ObjectID(objectID), objectsPackage, relativeObjectsDirectory);
    }

    Object& Object::fileByObjectFinder(const armarx::ObjectID& objectID, const std::string& objectsPackage,
                                       const std::string& relativeObjectsDirectory)
    {
        ObjectInfo info(objectsPackage, "", relativeObjectsDirectory, objectID);
        armarx::PackageFileLocation file = info.simoxXML();
        return this->file(file.package, file.relativePath);
    }

    Object& Object::alpha(float alpha)
    {
        if (alpha < 1)
        {
            overrideColor(simox::Color::white().with_alpha(alpha));
        }
        return *this;
    }
}


