#pragma once

#include "PluginUser.h"

#include <RobotAPI/interface/armem/client/MemoryListenerInterface.h>

#include <vector>


namespace armarx::armem::client::plugins
{
    class ListeningPlugin;


    /**
     * @brief A memory name system client which listens to the memory updates
     * topic (`MemoryListenerInterface`).
     *
     * Derive from this plugin user class to receive memory update events.
     */
    class ListeningPluginUser :
        virtual public PluginUser,
        virtual public MemoryListenerInterface
    {
    protected:

        ListeningPluginUser();
        virtual ~ListeningPluginUser() override;


        // MemoryListenerInterface
        virtual void
        memoryUpdated(const std::vector<data::MemoryID>& updatedSnapshotIDs,
                      const Ice::Current&) override;


    private:

        ListeningPlugin* listeningPlugin = nullptr;

    };

}
namespace armarx::armem::client
{
    using ListeningPluginUser = plugins::ListeningPluginUser;
}
namespace armarx::armem
{
    using ListeningClientPluginUser = client::ListeningPluginUser;
}
