#include "ice_conversions.h"

#include <RobotAPI/libraries/aron/core/navigator/data/container/Dict.h>
#include <RobotAPI/libraries/aron/core/navigator/type/container/Object.h>

#include <RobotAPI/libraries/armem/core/ice_conversions.h>
#include <RobotAPI/libraries/armem/core/ice_conversions_templates.h>


namespace armarx::armem::base
{

    void detail::toIceItem(data::detail::MemoryItem& ice, const armem::base::detail::MemoryItem& item)
    {
        toIce(ice.id, item.id());
    }
    void detail::fromIceItem(const data::detail::MemoryItem& ice, armem::base::detail::MemoryItem& item)
    {
        fromIce(ice.id, item.id());
    }


    void detail::toIce(aron::data::AronDictPtr& ice, const aron::datanavigator::DictNavigatorPtr& data)
    {
        ice = data ? data->toAronDictPtr() : nullptr;
    }
    void detail::fromIce(const aron::data::AronDictPtr& ice, aron::datanavigator::DictNavigatorPtr& data)
    {
        if (ice)
        {
            data = aron::datanavigator::DictNavigator::FromAronDictPtr(ice);
        }
        else
        {
            data = nullptr;
        };
    }

    void detail::toIce(aron::type::AronTypePtr& ice, const aron::typenavigator::ObjectNavigatorPtr& bo)
    {
        ice = bo ? bo->toAronPtr() : nullptr;
    }
    void detail::fromIce(const aron::type::AronTypePtr& ice, aron::typenavigator::ObjectNavigatorPtr& bo)
    {
        bo = ice
             ? aron::typenavigator::ObjectNavigator::DynamicCastAndCheck(aron::typenavigator::Navigator::FromAronType(ice))
             : nullptr;
    }

}
namespace armarx::armem
{
    void base::toIce(data::EntityInstanceMetadata& ice, const EntityInstanceMetadata& metadata)
    {
        ice.confidence = metadata.confidence;
        toIce(ice.timeArrivedMicroSeconds, metadata.timeArrived);
        toIce(ice.timeCreatedMicroSeconds, metadata.timeCreated);
        toIce(ice.timeSentMicroSeconds, metadata.timeSent);
    }
    void base::fromIce(const data::EntityInstanceMetadata& ice, EntityInstanceMetadata& metadata)
    {
        metadata.confidence = ice.confidence;
        fromIce(ice.timeArrivedMicroSeconds, metadata.timeArrived);
        fromIce(ice.timeCreatedMicroSeconds, metadata.timeCreated);
        fromIce(ice.timeSentMicroSeconds, metadata.timeSent);
    }


    void base::toIce(data::EntityInstanceMetadataPtr& ice, const EntityInstanceMetadata& metadata)
    {
        armem::toIce<data::EntityInstanceMetadata>(ice, metadata);
    }
    void base::fromIce(const data::EntityInstanceMetadataPtr& ice, EntityInstanceMetadata& metadata)
    {
        armem::fromIce<data::EntityInstanceMetadata>(ice, metadata);
    }

}
